/* Andrey N. Kuznetsov, Almaty, 2012 *
 * For educational purposes.         *
 * Under GPL 2.0                     */
//---------------------------------------------------------------------
#include "TListBox.h"
//---------------------------------------------------------------------
#define tr(s) String::fromUTF8(s)
//---------------------------------------------------------------------
TListBox::TListBox(const String& sName, ListBoxModel* pModel)
    : ListBox(sName, pModel)
{
    // Установливаем класс в качестве собственной модели
    setModel(this);
    setOutlineThickness(1);

    // Разрешаем множественное выделение элементов списка
    setMultipleSelectionEnabled(true);

    // Разрешаем выбор элементов наведением мыши
    setMouseMoveSelectsRows(true);

    setSize(400, 200);
}
//---------------------------------------------------------------------
TListBox::~TListBox()
{
}
//---------------------------------------------------------------------
int TListBox::getNumRows()
{
    // В списке - 4 строки
    return 4;
}
//---------------------------------------------------------------------
void TListBox::paintListBoxItem(int iRowNumber, Graphics& Painter, int iWidth, int iHeight, bool bIsRowSelected)
{
    // Если строка выбрана, закрашиваем её голубым цветом
    if(bIsRowSelected)
    {
        Painter.fillAll(Colours::lightblue);
    }

    // Цвет надписи - чёрный
    Painter.setColour(Colours::black);
    // Размер шрифта - 75% от высоты строки
    Painter.setFont(iHeight * 0.7f);

    // Рисуем текст строки с заданными параметрами, исходя из её номера
    Painter.drawText(tr("Элемент ") + String(iRowNumber + 1), 5, 0, iWidth, iHeight, Justification::centredLeft, true);
}
//---------------------------------------------------------------------
