/* Andrey N. Kuznetsov, Almaty, 2012 *
 * For educational purposes.         *
 * Under GPL 2.0                     */
//---------------------------------------------------------------------
#ifndef _TCentralComponent_h_
#define _TCentralComponent_h_
//---------------------------------------------------------------------
class TListBoxModel;
//---------------------------------------------------------------------
#include "../JuceLibraryCode/JuceHeader.h"
//---------------------------------------------------------------------
// Класс компонента содержимого.
// Наследует класс слушателя кнопок
// Наследует класс слушателя клавиш клавиатуры
class TCentralComponent  : public Component,
                           public ButtonListener,
                           public KeyListener
{
public:
    TCentralComponent();
    ~TCentralComponent();

    void paint(Graphics&);
    void resized();
    // Функция, отслеживающая щелчки по кнопке
    void buttonClicked(Button*);
    // Функция, отслеживающая нажатие клавиш клавиатуры
    bool keyPressed(const KeyPress&, Component*);

    // Добавление элемента списка
    void AddItem();
    // Удаление элемента списка
    void DeleteItem();

    // Модель данных
    TListBoxModel* pListBoxModel;

private:
    ListBox* pList;
    TextEditor* pInputEdit;
    TextButton* pAddButton;
    TextButton* pDeleteButton;

    // Предотвращает создание копии конструктора и оператора =
    TCentralComponent(const TCentralComponent&);
    const TCentralComponent& operator= (const TCentralComponent&);
};
//---------------------------------------------------------------------
#endif
