/* Andrey N. Kuznetsov, Almaty, 2012 *
 * For educational purposes.         *
 * Under GPL 2.0                     */
//---------------------------------------------------------------------
#include "TListBoxModel.h"
//---------------------------------------------------------------------
#define tr(s) String::fromUTF8(s)
//---------------------------------------------------------------------
TListBoxModel::TListBoxModel()
{
}
//---------------------------------------------------------------------
TListBoxModel::~TListBoxModel()
{
    // Перед завершением работы удаляем хранимые строки списка
    sItems.clear();
}
//---------------------------------------------------------------------
int TListBoxModel::getNumRows()
{
    // Число элементов списка - число хранимых строк
    return sItems.size();
}
//---------------------------------------------------------------------
void TListBoxModel::paintListBoxItem(int iRowNumber, Graphics& Painter, int iWidth, int iHeight, bool bIsRowSelected)
{
    // Если строка выбрана, закрашиваем её голубым цветом
    if(bIsRowSelected)
    {
        Painter.fillAll(Colours::lightblue);
    }

    // Цвет надписи - чёрный
    Painter.setColour(Colours::black);
    // Размер шрифта - 75% от высоты строки
    Painter.setFont(iHeight * 0.7f);

    // Рисуем текст строки с заданными параметрами, исходя из её номера
    Painter.drawText(sItems[iRowNumber], 
                     5, 0, iWidth, iHeight, 
                     Justification::centredLeft, true);
}
//---------------------------------------------------------------------
void TListBoxModel::listBoxItemClicked(int iRowNumber, const MouseEvent& Event)
{
}
//---------------------------------------------------------------------
void TListBoxModel::listBoxItemDoubleClicked(int iRowNumber, const MouseEvent& Event)
{
    // Если пользователь дважды щёлкнул по элементу списка
    // выводим текст соответствующей строки
    String sMessage = tr("Выбран элемент \"");
    sMessage += sItems[iRowNumber];
    sMessage += "\"";
    AlertWindow::showMessageBox(AlertWindow::InfoIcon, tr("Информация"), sMessage,
                                tr("Да"), 0);
}
//---------------------------------------------------------------------
void TListBoxModel::backgroundClicked()
{
}
//---------------------------------------------------------------------
void TListBoxModel::AddItem(String sText)
{
    // Добавляем новый элемент в массив строк
    sItems.add(sText);
}
//---------------------------------------------------------------------
void TListBoxModel::DeleteItem(int iItem)
{
    // Удаляем элемент из массива строк
    sItems.remove(iItem);
}
//---------------------------------------------------------------------
