/* Andrey N. Kuznetsov, Almaty, 2012 *
 * For educational purposes.         *
 * Under GPL 2.0                     */
//---------------------------------------------------------------------
#ifndef _TListBoxModel_h_
#define _TListBoxModel_h_
//---------------------------------------------------------------------
#include "../JuceLibraryCode/JuceHeader.h"
//---------------------------------------------------------------------
class TListBoxModel  : public ListBoxModel
{
public:
    TListBoxModel();
    ~TListBoxModel();
    
    // Задаём число элементов списка
    int getNumRows();
    // Отрисовка элемента списка
    void paintListBoxItem(int, Graphics&, int, int, bool);
    // Обработка щелчка и двойного щелчка мышью по элементу
    void listBoxItemClicked(int, const MouseEvent&);
    void listBoxItemDoubleClicked(int, const MouseEvent&);
    // Обработка щелчка мышью по свободному пространству списка
    void backgroundClicked();
    
    // Собственные функции добавления и удаления элемента списка
    void AddItem(String);
    void DeleteItem(int);
    
private:
    // Массив для хранения строк списка
    Array<String> sItems;

    // Предотвращает создание копии конструктора и оператора =
    TListBoxModel(const TListBoxModel&);
    const TListBoxModel& operator= (const TListBoxModel&);
};
//---------------------------------------------------------------------
#endif 
